<%#-- copyright
Nepenthes is a free and open project management software.
Copyright (C) 2024 The Nirvati developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

Nepenthes is a fork of OpenProject. The copyright follows:

Copyright (C) 2012-2024 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>
<%= breadcrumb_toolbar t(:label_permissions_report) %>
<% local_assigns[:additional_breadcrumb] = t(:label_permissions_report) %>
<% html_title t(:label_administration), t(:label_permissions_report) %>

<% (@calls || []).select(&:failure?).each do |call| %>
  <%= error_messages_for(call.result) %>
<% end %>

<%= form_tag(roles_path, method: :put, id: 'permissions_form') do %>
  <%= hidden_field_tag 'permissions[0]', '', id: nil %>

  <% group_permissions_by_module(@permissions).each do |mod, mod_permissions| %>
    <% module_name = mod.blank? ? "form--" + I18n.t('attributes.project') : "form--" + l_or_humanize(mod, prefix: 'project_module_').gsub(' ','_') %>
    <% escaped_name = module_name.parameterize %>
    <fieldset class="form--fieldset -collapsible" id= "<%= escaped_name %>">
      <legend class="form--fieldset-legend" >
        <%= mod.blank? ? I18n.t('attributes.project') : l_or_humanize(mod, prefix: 'project_module_') %>
      </legend>
      <div class="form--toolbar">
        <span class="form--toolbar-item">
          (<%= check_all_links escaped_name %>)
        </span>
      </div>

      <div class="generic-table--container">
        <div class="generic-table--results-container">
          <table class="generic-table">
            <colgroup>
              <col opHighlightCol>
              <col opHighlightCol>
              <col opHighlightCol>
              <col opHighlightCol>
              <col opHighlightCol>
              <col opHighlightCol>
            </colgroup>
            <thead>
              <tr>
                <th>
                  <div class="generic-table--sort-header-outer">
                    <div class="generic-table--sort-header">
                      <span>
                        <%=t(:label_permissions)%>
                      </span>
                    </div>
                  </div>
                </th>
                <% @roles.each do |role| %>
                  <th>
                    <div class="generic-table--sort-header-outer">
                      <div class="generic-table--sort-header">
                        <span>
                          <%= content_tag(role.builtin? ? 'em' : 'span', h(role.name)) %>
                          <%= link_to_function(
                                icon_wrapper('icon-context icon-checkmark',"#{t(:button_check_all)}/#{t(:button_uncheck_all)}"),
                                "OpenProject.helpers.toggleCheckboxesBySelector('input.role-#{role.id}')",
                                class: 'no-decoration-on-hover',
                                title: "#{t(:button_check_all)}/#{t(:button_uncheck_all)}") %>
                        </span>
                      </div>
                    </div>
                  </th>
                <% end %>
              </tr>
            </thead>
            <tbody>
              <% mod_permissions.each do |permission| %>
                <tr class="permission-<%= permission.name %>">
                  <td>
                    <%= link_to_function(
                          icon_wrapper('icon-context icon-checkmark',"#{t(:button_check_all)}/#{t(:button_uncheck_all)}"),
                          "OpenProject.helpers.toggleCheckboxesBySelector('.permission-#{permission.name} input')",
                          class: 'no-decoration-on-hover',
                          title: "#{t(:button_check_all)}/#{t(:button_uncheck_all)}") %>
                    <%= l_or_humanize(permission.name, prefix: 'permission_') %>
                  </td>
                  <% @roles.each do |role| %>
                    <td>
                      <% if setable_permissions(role).include? permission %>
                        <%= check_box_tag "permissions[#{role.id}][]", permission.name, (role.permissions.include? permission.name), id: nil, class: "role-#{role.id}" %>
                      <% end %>
                    </td>
                  <% end %>
                </tr>
              <% end %>
            </tbody>
          </table>

        </div>
      </div>
    </fieldset>
  <% end %>

  <p><%= styled_button_tag t(:button_save), class: '-primary -with-icon icon-checkmark' %></p>
<% end %>
